MODULE MODULE_CHEMVARS

   IMPLICIT NONE

!
! the next are variables that chemdriver will need
!
   REAL, PARAMETER             :: epsilc = 1.e-16
!  INTEGER, PARAMETER          :: num_emis_ant = 9
   INTEGER, PARAMETER          :: num_emis_dust = 5
   INTEGER, PARAMETER          :: num_emis_seas = 4
   INTEGER, PARAMETER          :: ne_area = 41
   INTEGER, PARAMETER          :: nmegan = 1
!   INTEGER, PARAMETER          :: kemit = 1
   INTEGER                     :: stepbioe,stepfirepl
   REAL, ALLOCATABLE :: chem( :, :, :, : )
   REAL, ALLOCATABLE :: emis_ant( :, :, :,:)
   REAL, ALLOCATABLE :: emis_vol( :, :, :,:)
   REAL, ALLOCATABLE :: relhum( :, :, : )
   REAL, ALLOCATABLE :: h2oai( :, :, : )
   REAL, ALLOCATABLE :: h2oaj( :, :, : )
   REAL, ALLOCATABLE :: e_bio( :, :, : )
   REAL, ALLOCATABLE :: dms_0( :, :)
   REAL, ALLOCATABLE :: ttday( :, :)
   REAL, ALLOCATABLE :: tcosz( :, :)
   REAL, ALLOCATABLE :: erod( :, :,:)
   REAL, ALLOCATABLE :: emis_dust( :, :, :,:)
   REAL, ALLOCATABLE :: emis_seas( :, :, :,:)
   REAL, ALLOCATABLE :: backg_oh( :, :, : )
   REAL, ALLOCATABLE :: backg_h2o2( :, :, : )
   REAL, ALLOCATABLE :: backg_no3( :, :, : )
   REAL, ALLOCATABLE :: ebu_in_no(  :, : )
   REAL, ALLOCATABLE :: ebu_in_co( :, : )
   REAL, ALLOCATABLE :: ebu_in_co2(  :, : )
   REAL, ALLOCATABLE :: ebu_in_eth(  :, : )
   REAL, ALLOCATABLE :: ebu_in_hc3(  :, : )
   REAL, ALLOCATABLE :: ebu_in_hc5(  :, : )
   REAL, ALLOCATABLE :: ebu_in_hc8(  :, : )
   REAL, ALLOCATABLE :: ebu_in_ete(  :, : )
   REAL, ALLOCATABLE :: ebu_in_olt(  :, : )
   REAL, ALLOCATABLE :: ebu_in_oli(  :, : )
   REAL, ALLOCATABLE :: ebu_in_pm25( :, : )
   REAL, ALLOCATABLE :: ebu_in_pm10( :, : )
   REAL, ALLOCATABLE :: ebu_in_oc(  :, : )
   REAL, ALLOCATABLE :: ebu_in_bc(  :, : )
   REAL, ALLOCATABLE :: ebu_in_so2(  :, : )
   REAL, ALLOCATABLE :: ebu_in_sulf( :, : )
   REAL, ALLOCATABLE :: ebu_in_dien( :, : )
   REAL, ALLOCATABLE :: ebu_in_iso(  :, : )
   REAL, ALLOCATABLE :: ebu_in_api(  :, : )
   REAL, ALLOCATABLE :: ebu_in_lim(  :, : )
   REAL, ALLOCATABLE :: ebu_in_tol(  :, : )
   REAL, ALLOCATABLE :: ebu_in_xyl(  :, : )
   REAL, ALLOCATABLE :: ebu_in_csl(  :, : )
   REAL, ALLOCATABLE :: ebu_in_hcho( :, : )
   REAL, ALLOCATABLE :: ebu_in_ald(  :, : )
   REAL, ALLOCATABLE :: ebu_in_ket( :, : )
   REAL, ALLOCATABLE :: ebu_in_macr(  :, : )
   REAL, ALLOCATABLE :: ebu_in_ora1(  :, : )
   REAL, ALLOCATABLE :: ebu_in_ora2(  :, : )
   REAL, ALLOCATABLE :: ebu_no( :, :, : )
   REAL, ALLOCATABLE :: ebu_co( :, :, : )
   REAL, ALLOCATABLE :: ebu_co2( :, :, : )
   REAL, ALLOCATABLE :: ebu_eth( :, :, : )
   REAL, ALLOCATABLE :: ebu_hc3( :, :, : )
   REAL, ALLOCATABLE :: ebu_hc5( :, :, : )
   REAL, ALLOCATABLE :: ebu_hc8( :, :, : )
   REAL, ALLOCATABLE :: ebu_ete( :, :, : )
   REAL, ALLOCATABLE :: ebu_olt( :, :, : )
   REAL, ALLOCATABLE :: ebu_oli( :, :, : )
   REAL, ALLOCATABLE :: ebu_pm25( :, :, : )
   REAL, ALLOCATABLE :: ebu_pm10( :, :, : )
   REAL, ALLOCATABLE :: ebu_oc( :, :, : )
   REAL, ALLOCATABLE :: ebu_bc( :, :, : )
   REAL, ALLOCATABLE :: ebu_so2( :, :, : )
   REAL, ALLOCATABLE :: ebu_sulf( :, :, : )
   REAL, ALLOCATABLE :: ebu_dien( :, :, : )
   REAL, ALLOCATABLE :: ebu_iso( :, :, : )
   REAL, ALLOCATABLE :: ebu_api( :, :, : )
   REAL, ALLOCATABLE :: ebu_lim( :, :, : )
   REAL, ALLOCATABLE :: ebu_tol( :, :, : )
   REAL, ALLOCATABLE :: ebu_xyl( :, :, : )
   REAL, ALLOCATABLE :: ebu_csl( :, :, : )
   REAL, ALLOCATABLE :: ebu_hcho( :, :, : )
   REAL, ALLOCATABLE :: ebu_ald( :, :, : )
   REAL, ALLOCATABLE :: ebu_ket( :, :, : )
   REAL, ALLOCATABLE :: ebu_macr( :, :, : )
   REAL, ALLOCATABLE :: ebu_ora1( :, :, : )
   REAL, ALLOCATABLE :: ebu_ora2( :, :, : )
   REAL, ALLOCATABLE :: mean_fct_agtf( :,  : )
   REAL, ALLOCATABLE :: mean_fct_agef( :,  : )
   REAL, ALLOCATABLE :: mean_fct_agsv( :,  : )
   REAL, ALLOCATABLE :: mean_fct_aggr( :,  : )
   REAL, ALLOCATABLE :: firesize_agtf( :,  : )
   REAL, ALLOCATABLE :: firesize_agef( :,  : )
   REAL, ALLOCATABLE :: firesize_agsv( :,  : )
   REAL, ALLOCATABLE :: firesize_aggr( :,  : )
   REAL, ALLOCATABLE :: ash_fall( :,  : )
   REAL, ALLOCATABLE :: dust_fall( :,  : )
   REAL, ALLOCATABLE :: pm2_5_dry( : , : , : )
   REAL, ALLOCATABLE :: pm2_5_dry_ec( : , : , : )
   REAL, ALLOCATABLE :: pm10( : , : , : )
   REAL, ALLOCATABLE :: sebio_iso( : , : )
   REAL, ALLOCATABLE :: sebio_oli( : , : )
   REAL, ALLOCATABLE :: sebio_api( : , : )
   REAL, ALLOCATABLE :: sebio_lim( : , : )
   REAL, ALLOCATABLE :: sebio_xyl( : , : )
   REAL, ALLOCATABLE :: sebio_hc3( : , : )
   REAL, ALLOCATABLE :: sebio_ete( : , : )
   REAL, ALLOCATABLE :: sebio_olt( : , : )
   REAL, ALLOCATABLE :: sebio_ket( : , : )
   REAL, ALLOCATABLE :: sebio_ald( : , : )
   REAL, ALLOCATABLE :: sebio_hcho( : , : )
   REAL, ALLOCATABLE :: sebio_eth( : , : )
   REAL, ALLOCATABLE :: sebio_ora2( : , : )
   REAL, ALLOCATABLE :: sebio_co( : , : )
   REAL, ALLOCATABLE :: sebio_nr( : , : )
   REAL, ALLOCATABLE :: noag_grow( : , : )
   REAL, ALLOCATABLE :: noag_nongrow( : , : )
   REAL, ALLOCATABLE :: nononag( : , : )
   REAL, ALLOCATABLE :: slai( : , : )
   REAL, ALLOCATABLE :: ebio_iso( : , : )
   REAL, ALLOCATABLE :: ebio_oli( : , : )
   REAL, ALLOCATABLE :: ebio_api( : , : )
   REAL, ALLOCATABLE :: ebio_lim( : , : )
   REAL, ALLOCATABLE :: ebio_xyl( : , : )
   REAL, ALLOCATABLE :: ebio_hc3( : , : )
   REAL, ALLOCATABLE :: ebio_ete( : , : )
   REAL, ALLOCATABLE :: ebio_olt( : , : )
   REAL, ALLOCATABLE :: ebio_ket( : , : )
   REAL, ALLOCATABLE :: ebio_ald( : , : )
   REAL, ALLOCATABLE :: ebio_hcho( : , : )
   REAL, ALLOCATABLE :: ebio_eth( : , : )
   REAL, ALLOCATABLE :: ebio_ora2( : , : )
   REAL, ALLOCATABLE :: ebio_co( : , : )
   REAL, ALLOCATABLE :: ebio_nr( : , : )
   REAL, ALLOCATABLE :: ebio_no( : , : )

   !shc stuff for MEGAN v2.04

   real, ALLOCATABLE :: EFmegan(:, : , :)


   real, ALLOCATABLE :: msebio_isop(:, : )
   real, ALLOCATABLE :: pftp_bt(:, : )
   real, ALLOCATABLE :: pftp_nt(:, : )
   real, ALLOCATABLE :: pftp_sb(:, : )
   real, ALLOCATABLE :: pftp_hb(:, : )

   real, ALLOCATABLE :: mlai(:, :, : )
   real, ALLOCATABLE :: mtsa(:, :, : )
   real, ALLOCATABLE :: mswdown(:, :, : )

   real, ALLOCATABLE :: mebio_isop(:, : )
   real, ALLOCATABLE :: mebio_apin(:, : )
   real, ALLOCATABLE :: mebio_bpin(:, : )
   real, ALLOCATABLE :: mebio_bcar(:, : )
   real, ALLOCATABLE :: mebio_acet(:, : )
   real, ALLOCATABLE :: mebio_mbo(:, : )
   real, ALLOCATABLE :: mebio_no(:, : )
!
! stuff for optical driver
!
! next three are for feedback to physics
!
   REAL, ALLOCATABLE :: extt( :, :, :, : )
   REAL, ALLOCATABLE :: ssca( :, :, :, : )
   REAL, ALLOCATABLE :: asympar( :, :, :, : )
!
! output diagnosics
!
   REAL, ALLOCATABLE :: aod( :,: )
   REAL, ALLOCATABLE :: ext_coeff( :, :, :,:)
   REAL, ALLOCATABLE :: bscat_coeff( :, :, :,:)
   REAL, ALLOCATABLE :: asym_par( :, :, :,:)
!
! optical calculations, necessary for feedback to physics and diagnostics
   real, ALLOCATABLE :: tauaersw(:, : , :, : )
   real, ALLOCATABLE :: tauaerlw(:, : , :, : )
   real, ALLOCATABLE :: bscoefsw(:, : , :, : )
   real, ALLOCATABLE :: gaersw(:, : , :, : )
   real, ALLOCATABLE :: waersw(:, : , :, : )
   real, ALLOCATABLE :: tauaer1(:, : , : )
   real, ALLOCATABLE :: tauaer2(:, : , : )
   real, ALLOCATABLE :: tauaer3(:, : , : )
   real, ALLOCATABLE :: tauaer4(:, : , : )
   real, ALLOCATABLE :: gaer1(:, : , : )
   real, ALLOCATABLE :: gaer2(:, : , : )
   real, ALLOCATABLE :: gaer3(:, : , : )
   real, ALLOCATABLE :: gaer4(:, : , : )
   real, ALLOCATABLE :: waer1(:, : , : )
   real, ALLOCATABLE :: waer2(:, : , : )
   real, ALLOCATABLE :: waer3(:, : , : )
   real, ALLOCATABLE :: waer4(:, : , : )
   real, ALLOCATABLE :: bscoef1(:, : , : )
   real, ALLOCATABLE :: bscoef2(:, : , : )
   real, ALLOCATABLE :: bscoef3(:, : , : )
   real, ALLOCATABLE :: bscoef4(:, : , : )
   real, ALLOCATABLE :: l2aer(:, : , : , : )
   real, ALLOCATABLE :: l3aer(:, : , : , : )
   real, ALLOCATABLE :: l4aer(:, : , : , : )
   real, ALLOCATABLE :: l5aer(:, : , : , : )
   real, ALLOCATABLE :: l6aer(:, : , : , : )
   real, ALLOCATABLE :: l7aer(:, : , : , : )

END MODULE MODULE_CHEMVARS
